public static void printPermissionInfo(Context context) throws Exception {
    PackageManager pm = context.getPackageManager();
    List<PermissionGroupInfo> groupList = pm.getAllPermissionGroups(0);
    groupList.add(null); // ungrouped permissions
    Method protectionToString = PermissionInfo.class.getDeclaredMethod("protectionToString",
            int.class);
    for (PermissionGroupInfo group : groupList) {
        try {
            String name = group == null ? null : group.name;
            List<PermissionInfo> permissionInfos = pm.queryPermissionsByGroup(name, 0);
            for (PermissionInfo permissionInfo : permissionInfos) {
                String protection = (String) protectionToString.invoke(permissionInfo,
                        permissionInfo.protectionLevel);
                System.out.println(permissionInfo.name + " " + protection);
            }
        } catch (PackageManager.NameNotFoundException ignored) {
        }
    }
}
