#setwd("/Users/sebastian/git/kiefer/stackoverflow-in-github/references-recall/java-high-popularity-3000-unrated/eval/8")
setwd("E:/Git/kiefer/stackoverflow-in-github/references-recall/java-high-popularity-3000-unrated/eval/8")

NAME="mt-40"

# READ DATA
true_positives <- read.csv(file=paste("true-positives-", NAME, ".csv", sep=""), header=FALSE, sep=",", quote="\"", na.strings=c(""), stringsAsFactors=FALSE) 
names(true_positives) <- c("snippet_file", "occurrence_file")
results  <- read.csv(file=paste(NAME, "-visual.csv", sep=""), header=TRUE, sep=",", quote="\"", na.strings=c(""), stringsAsFactors=FALSE) 

# CLEAN DATA
results$snippet_file <- gsub("/home/lsdroot/git/kiefer/snippet-sets/gh/", "", results$snippet_file)
for (i in 1:10) {
  results$snippet_file <- trimws(gsub(paste("/", i, ".java", sep=""), "", results$snippet_file)) 
}
results$snippet_file <- trimws(gsub(".java", "", results$snippet_file)) 
results$occurrence_file <- trimws(gsub("/shared/files-with-references/java-high-popularity-3000-unrated/", "", results$occurrence_file))

# MERGE DATA
true_positives_merged <- merge(true_positives, results, by.x=c("snippet_file", "occurrence_file"), file, by.y=c("snippet_file", "occurrence_file"))
false_positives_merged <- results[setdiff(1:nrow(results), true_positives_merged$id),]

# WRITE DATA
write.table(true_positives_merged, file=paste("true-positives-", NAME, "-merged.csv", sep=""), sep=",", col.names=TRUE, row.names=FALSE, na="", quote=TRUE, qmethod="double")
write.table(false_positives_merged, file=paste("false-positives-", NAME, "-merged.csv", sep=""), sep=",", col.names=TRUE, row.names=FALSE, na="", quote=TRUE, qmethod="double")

# ANALYISIS
nrow(results)
# mt-25: 268 / mt-40: 103
unique_snippet_file <- unique.data.frame(results[,c("snippet_file", "occurrence_file")])
nrow(unique_snippet_file)
# mt-25: 84 / mt-40: 51
nrow(true_positives)
# mt-25: 72 / mt-40: 48
