#setwd("/Users/sebastian/git/kiefer/stackoverflow-in-github/references-recall/java-high-popularity-3000-unrated/eval/")
setwd("E:/Git/kiefer/stackoverflow-in-github/references-recall/java-high-popularity-3000-unrated/eval/")

NAMES = c("gh-mt40", "top100-mt40", "so-mt40")

file_names <- list()
repo_names <- list()
snippet_files <- list()
matches <- data.frame(snippet_id=character(), occurrence_file=character(), stringsAsFactors=FALSE)

# READ DATA
for (name in NAMES) {
    data <- read.csv(file=paste(name, "/", name, "_unique_snippet_file.csv", sep=""), header=TRUE, sep=",", quote="\"", na.strings=c(""), stringsAsFactors=FALSE)    
    file_names <- unlist(append(file_names, unique(data$occurrence_file)))
    repo_names <- unlist(append(repo_names, unique(data$repo_name)))
    snippet_files <- unlist(append(snippet_files, unique(data$snippet_file)))
    matches <- rbind(matches, data[,c("snippet_id", "occurrence_file")], stringsAsFactors=FALSE)
}

length(unique(file_names))
# 309
length(unique(repo_names))
# 207
length(unique(snippet_files))
# 114
nrow(unique.data.frame(matches))
# 370

# READ LIST OF FILES WITH REFERENCE
files_with_refs <- read.csv(file="../files-with-references_all.csv", header=FALSE, sep=",", quote="\"", na.strings=c(""), stringsAsFactors=FALSE) 
names(files_with_refs) <- c("file")
matches_with_ref <- merge(matches, files_with_refs, by.x="occurrence_file", by.y="file")

nrow(unique(matches_with_ref))
# 72
