#!/bin/bash

# ground truth is the union of false negatives and true positives
set_ground_truth="$1"
set_selected_elements="$2"
set_true_positives="$3"

# cf. http://stackoverflow.com/a/25283648
comm -12 <(sort "$set_ground_truth") <(sort "$set_selected_elements") > "$set_true_positives"

ground_truth=$(sort -u "$set_ground_truth" | wc -l)
selected_elements=$(sort -u "$set_selected_elements" | wc -l)
true_positives=$(sort -u "$set_true_positives" | wc -l)

# http://stackoverflow.com/a/12723330
precision=`bc <<< "scale=2; $true_positives / $selected_elements"`
recall=`bc <<< "scale=2; $true_positives / $ground_truth"`

echo $precision,$recall



