#!/bin/bash

precisionRecallLog="precision-recall.csv"
snippetsDir="$HOME/git/kiefer/snippet-sets/gh/"
projectsDir="/shared/files-with-references/java-high-popularity-3000-unrated/"
runtimeLog="runtime.log"

# https://zxq9.com/archives/795
date +%s%N  > $runtimeLog

for ignoreLiterals in 0
do
  for ignoreIdentifiers in 1
  do
    for ignoreAnnotations in 1
    do
      # for minimumTokens in 25
      for minimumTokens in {15..100..5}
      do
        additionalArguments=""
        additionalArgumentsHash=""
        if [ "$ignoreAnnotations" -gt "0" ]
        then
          additionalArguments=" --ignore-annotations"
          additionalArgumentsHash="$additionalArgumentsHash-ia"
        fi
        if [ "$ignoreIdentifiers" -gt "0" ]
        then
          additionalArguments=" --ignore-identifiers"
          additionalArgumentsHash="$additionalArgumentsHash-ii"
        fi
        if [ "$ignoreLiterals" -gt "0" ]
        then
          additionalArguments=" --ignore-literals"
          additionalArgumentsHash="$additionalArgumentsHash-il"
        fi

        argumentsHash="mt-$minimumTokens$additionalArgumentsHash"
        outputFile="results/$argumentsHash.csv"
        outputFileVisual="results/$argumentsHash-visual.csv"

        ../yennork/find-snippets.sh \
          $snippetsDir \
          $projectsDir \
          cache/snippets/$argumentsHash/ \
          cache/files-with-references/$argumentsHash/ \
          "--minimum-tokens $minimumTokens $additionalArguments" \
          outputFormatRelation > $outputFile # stdout-redirect must not be on its own
                                              # line

         # adapt output format to that of the ground-truth.csv
          sed -e "s/\/shared\/files-with-references\/java-high-popularity-3000-unrated\///g" -i $outputFile
          sed -r "s/^[^,]*(so-answer-[0-9]*)[^,]*/\1/g" -i $outputFile

          precisionRecall=$(./precision_recall.sh ground-truth.csv $outputFile true-positives.csv)
          echo "$argumentsHash,$precisionRecall" >> "$precisionRecallLog"

        ../yennork/find-snippets.sh \
          $snippetsDir \
          $projectsDir \
          cache/snippets/$argumentsHash-visual/ \
          cache/files-with-references/$argumentsHash-visual/ \
          "--minimum-tokens $minimumTokens $additionalArguments" \
          outputFormatVisual > $outputFileVisual # stdout-redirect must not be on its own
                                                 # line

      done
    done
  done
done

date +%s%N   >> $runtimeLog
