#!/bin/bash

precisionRecallLog="precision-recall.csv"
snippetsDir="$HOME/git/kiefer/snippet-sets/so/"
projectsDir="/shared/repositories/java-high-popularity-3000-unrated/"
runtimeLog="runtime.log"

# https://zxq9.com/archives/795
date +%s%N  > $runtimeLog

for ignoreLiterals in 0
do
  for ignoreIdentifiers in 0
  do
    for ignoreAnnotations in 0
    do
      for minimumTokens in 40
      do
        additionalArguments=""
        if [ "$ignoreAnnotations" -gt "0" ]
        then
          additionalArguments=" --ignore-annotations"
        fi
        if [ "$ignoreIdentifiers" -gt "0" ]
        then
          additionalArguments=" --ignore-identifiers"
        fi
        if [ "$ignoreLiterals" -gt "0" ]
        then
          additionalArguments=" --ignore-literals"
        fi

        # http://unix.stackexchange.com/a/218522
        for f in $projectsDir*; do
            if [ -d ${f} ]; then  # Will not run if no directories are available
                outputFileVisual="results/$(basename "$f").csv"
                
                # only use visual output format here
                ../yennork/find-snippets.sh \
                  $snippetsDir \
                  $f \
                  cache/snippets/$(basename "$f")/ \
                  cache/java-projects/$(basename "$f")/ \
                  "--minimum-tokens $minimumTokens $additionalArguments" \
                  outputFormatVisual > $outputFileVisual # stdout-redirect must not be on its own
                                                         # line
            fi
        done
      done
    done
  done
done

date +%s%N   >> $runtimeLog
