# Analysis of Stack Overflow Occurrences

# let strings alone, otherwise it causes trouble
# with later assignments of "type"
options(stringsAsFactors =FALSE)


# soo <- read.csv("stackoverflow-urls-copied.csv", header = TRUE, stringsAsFactors = FALSE)
# soo <- cbind(soo, repository = "")
# 
# getRepositoryFromFilePath <- function(path) {
#   splitted <- strsplit(path, "/")
#   splitted[[1]][7]
# }
# 
# for (i in 1:dim(soo)[1]) {
#   soo[i,]$repository <- getRepositoryFromFilePath(soo[i,]$file)
# }
# 
# write.csv(soo, 'stackoverflow-urls-analysed.csv')


soo <- read.csv("stackoverflow-urls-analysed.csv", header = TRUE, stringsAsFactors = FALSE)

nrow(soo)
# 739 references in total

table(subset(soo, select=c(type)))

sooA = subset(soo, type == "answer-long" | type == "answer-tinyurl")
nrow(sooA)
# 232 answer references
nrow(unique(subset(sooA, select=c(answer_id))))
# 157 unique answers referenced

sooQ = subset(soo, type == "question-long" |
                   type == "question-short" | 
                   type == "question-short-with-slash" |
                   type == "question-tinyurl")
nrow(sooQ)
# 498 question references
nrow(unique(subset(sooQ, select=c(question_id))))
# 368 unique questions referenced

# filter on our extracted answers
sooAnswerReferences <- subset(sooA, copystate == "x" | 
                                   copystate == "dup")
nrow(sooAnswerReferences) # 182 answer-references

# don't know why i need to use length after unique, instead of nrow
length(unique(sooAnswerReferences$file)) # 156 files
length(unique(sooAnswerReferences$repository)) # 79 repositories
length(unique(sooAnswerReferences$answer_id)) # 118 unique answers,
                                              # across all files and repositories

# The following excludes duplicate answer-references on a file basis;
# maybe the best way to exclude unintended duplicates
sooAnswersInFiles <- unique(subset(sooAnswerReferences, select = c(file, answer_id)))
nrow(sooAnswersInFiles) # 163 references to answers,
                        # not counting multiple references to the same answer
                        # in one file
m <- data.frame(table(sooAnswersInFiles$file))
nrow(m[m$Freq > 1,]) # 6 files of them reference more than one answer


sooAnswersInRepositories <- unique(subset(sooAnswerReferences, select = c(repository, answer_id)))
nrow(sooAnswersInRepositories) # 133 references to answers,
                               # not counting multiple references to the same
                               # answer in one repository

sort(table(sooAnswersInRepositories$repository))
# repository openstreetmap-josm is leading with 9 references

