# Stack Overflow Occurrences

# let strings alone, otherwise it causes trouble
# with later assignments of "type"
options(stringsAsFactors =FALSE)

soo <- data.frame()
read_urls <- function() {
  soo <<- read.csv("stackoverflow-urls.csv", header = TRUE, stringsAsFactors = FALSE)
  soo <<- cbind(soo, type = "")
  soo <<- cbind(soo, question_id = "")
  soo <<- cbind(soo, answer_id = "")
}

urlmapping <- list(patterns = NA, types = NA, question_id = NA, answer_id = NA)
define_classification <- function() {
  urlmapping$patterns[1] <<- "^https?://stackoverflow.com/q/([[:digit:]]+)(?:/[[:digit:]]+)?$"
  urlmapping$types[1] <<- "question-tinyurl"
  urlmapping$question_id[1] <<- "\\1"
  urlmapping$answer_id[1] <<- ""
  
  urlmapping$patterns[3] <<- "^https?://stackoverflow.com/questions/([[:digit:]]+)/[[:alnum:]-]+/?$"
  urlmapping$types[3] <<- "question-long"
  urlmapping$question_id[3] <<- "\\1"
  urlmapping$answer_id[3] <<- ""
  
  urlmapping$patterns[2] <<- "^https?://stackoverflow.com/a/([[:digit:]]+)(?:/[[:digit:]]+)?$"
  urlmapping$types[2] <<- "answer-tinyurl"
  urlmapping$question_id[2] <<- ""
  urlmapping$answer_id[2] <<- "\\1"
  
  
  urlmapping$patterns[4] <<- "^https?://stackoverflow.com/questions/([[:digit:]]+)/[[:alnum:]-]+/([[:digit:]]+)(?:#[[:digit:]]+)?$"
  urlmapping$types[4] <<- "answer-long"
  urlmapping$question_id[4] <<- "\\1"
  urlmapping$answer_id[4] <<- "\\2"
  
  urlmapping$patterns[10] <<- "^https?://stackoverflow.com/questions/([[:digit:]]+)/[[:alnum:]-]+#answer-([[:digit:]]+)$"
  urlmapping$types[10] <<- "answer-long"
  urlmapping$question_id[10] <<- "\\1"
  urlmapping$answer_id[10] <<- "\\2"
  
  urlmapping$patterns[5] <<- "^https?://stackoverflow.com/questions/([[:digit:]]+)$"
  urlmapping$types[5] <<- "question-short"
  urlmapping$question_id[5] <<- "\\1"
  urlmapping$answer_id[5] <<- ""
  
  urlmapping$patterns[6] <<- "^https?://stackoverflow.com/questions/([[:digit:]]+)/$"
  urlmapping$types[6] <<- "question-short-with-slash"
  urlmapping$question_id[6] <<- "\\1"
  urlmapping$answer_id[6] <<- ""
  
  urlmapping$patterns[7] <<- "^https?://stackoverflow.com/users/[[:digit:]]+/.*$"
  urlmapping$types[7] <<- "user"
  urlmapping$question_id[7] <<- ""
  urlmapping$answer_id[7] <<- ""
  
  urlmapping$patterns[8] <<- "^https?://stackoverflow.com/questions/([[:digit:]]+)/[[:alnum:]-]+/([[:digit:]]+)#comment[[:digit:]]+_[[:digit:]]+$"
  urlmapping$types[8] <<- "comment"
  urlmapping$question_id[8] <<- "\\1"
  urlmapping$answer_id[8] <<- "\\2"
  
  urlmapping$patterns[11] <<- "^https?://stackoverflow.com/questions/([[:digit:]]+)/[[:alnum:]-]+#comment[[:digit:]]+_([[:digit:]]+)$"
  urlmapping$types[11] <<- "comment"
  urlmapping$question_id[11] <<- "\\1"
  urlmapping$answer_id[11] <<- "\\2"
  
  urlmapping$patterns[9] <<- "^https?://stackoverflow.com/tags/[[:alnum:]]+$"
  urlmapping$types[9] <<- "tag"
  urlmapping$question_id[9] <<- ""
  urlmapping$answer_id[9] <<- ""
  
  urlmapping$patterns[12] <<- "^https?://stackoverflow.com/questions$"
  urlmapping$types[12] <<- "questions"
  urlmapping$question_id[12] <<- ""
  urlmapping$answer_id[12] <<- ""
}

classify_urls <- function() {
  for (i in 1:dim(soo)[1]) {
    for (j in 1:length(urlmapping$patterns)) {
      pattern <- urlmapping$patterns[j]
      type <- urlmapping$types[j]
      question_id <- urlmapping$question_id[j]
      answer_id <- urlmapping$answer_id[j]
      if (grepl(pattern, soo[i,]$url, perl = TRUE)) {
        soo[i,]$type <<- type
        soo[i,]$question_id <<- sub(pattern, question_id, soo[i,]$url, fixed= FALSE)
        soo[i,]$answer_id <<- sub(pattern, answer_id, soo[i,]$url, fixed= FALSE)
      }
    }
  }
}

export_classified_urls <- function() {
  write.csv(soo, 'stackoverflow-urls-classified.csv')
}

read_urls()
define_classification()
classify_urls()
export_classified_urls()