#!/bin/bash
##
# Takes the URL to an archive and a target location. It downloads
# the archive and unpacks it into the target location. The target location is relative to the current working directory.

if [ $# -ne 2 ]; then
  exit 1
fi

archiveUrl="$1"
destination="$2"
# @fixme The following requires that "$tmp" isn't a file in
#        the repository itself. Let's assume there never is one, for now.
tmp="__.__master.zip"

# @todo test if destination directory is empty; warn if not
mkdir -p "$destination"
cd "$destination"
# curl -L: follow redirects
echo "$archiveUrl"
curl -L "$archiveUrl" > "$tmp"
unzip "$tmp"
rm "$tmp"
cd $OLDPWD

