#!/bin/bash
##
# Reads a list of github projects from stdin and downloads them to a given 
# target location.
#
# Each line names one project in the form "owner/project". The target location
# is given as a parameter, and each project will be downloaded into a subfolder
# in the form "owner-project".

if [ $# -ne 1 ]; then
  exit 1
fi

destinationPrefix="$1"

while read ownerSlashProject; do

  githubArchiveUrl="https://github.com/${ownerSlashProject}/archive/master.zip"

  ownerMinusProject=${ownerSlashProject//\//-} # cf. http://stackoverflow.com/a/2871187
  destination="$destinationPrefix/$ownerMinusProject/"

  ./download-and-unpack.sh "$githubArchiveUrl" "$destination" 

done < /dev/stdin
