setwd("<YOUR DIRECTORY>")

# read data
gh <- read.csv(file="gh_index.csv", header=FALSE, sep=",", quote="\"", na.strings=c(""), stringsAsFactors=FALSE)
names(gh) <- c("answer")
top100 <- read.csv(file="top100_index.csv", header=FALSE, sep=",", quote="\"", na.strings=c(""), stringsAsFactors=FALSE)
names(top100) <- c("answer")

complete_setdiff <- function(x, y) {
  sort(c(setdiff(x, y),
         setdiff(y, x)))
}

intersect(gh$answer, top100$answer)
# [1] "so-answer-10872497" "so-answer-1343796"  "so-answer-15476793"
# [4] "so-answer-16800527" "so-answer-21460179" "so-answer-26196831"
# [7] "so-answer-3054692"  "so-answer-309718"   "so-answer-363692"  
# [10] "so-answer-4057470"  "so-answer-41156"    "so-answer-4265472" 
# [13] "so-answer-4761689"  "so-answer-5445161"  "so-answer-6219382" 
# [16] "so-answer-7201825"  "so-answer-823966"   "so-answer-8685959"
# -> 18 answers
# ->  1+1+2
#     +2+1+2
#     +2+1+1
#     +1+2+1
#     +2+1+1
#     +1+2+2
#     =26 snippets

library(stringr)
regex <- paste("(so-answer-\\d+)", sep="")
matches <- str_match_all(rbind(gh, top100), regex)
length(unique(unlist(matches)))
# 169 distinct snippet ids
# -> more than 169 snippet files, because multipe snippet files per id

all <- rbind(gh, top100)
length(unlist(unique(all)))
# 169
